﻿Imports System.Data

Partial Class _Default
    Inherits System.Web.UI.Page

    Private Function GetTableGenres() As DataTable
        ' Create a new DataTable.
        Dim table As System.Data.DataTable = New DataTable("Genres")
        ' Declare variables for DataColumn and DataRow objects.
        Dim column As DataColumn
        Dim row As DataRow

        ' Create new DataColumn, set DataType, 
        ' ColumnName and add to DataTable.    
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ID"
        column.[ReadOnly] = True
        ' Add the Column to the DataColumnCollection.
        table.Columns.Add(column)

        ' Create second column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ParentID"
        column.AutoIncrement = False
        column.Caption = "ParentID"
        column.[ReadOnly] = False
        column.Unique = False
        column.AllowDBNull = True

        ' Add the column to the table. 
        table.Columns.Add(column)

        ' Create third column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Name"
        column.AutoIncrement = False
        column.Caption = "Name"
        column.[ReadOnly] = False
        column.Unique = False
        ' Add the column to the table.
        table.Columns.Add(column)


        ' Make the ID column the primary key column.
        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = table.Columns("ID")
        table.PrimaryKey = PrimaryKeyColumns

        row = table.NewRow()
        row("ID") = 1
        row("ParentID") = DBNull.Value
        row("Name") = "Metal"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 2
        row("ParentID") = DBNull.Value
        row("Name") = "Rock"
        table.Rows.Add(row)

        Return table

    End Function

    Private Function GetTableBands() As DataTable
        ' Create a new DataTable.
        Dim table As System.Data.DataTable = New DataTable("Bands")
        ' Declare variables for DataColumn and DataRow objects.
        Dim column As DataColumn
        Dim row As DataRow

        ' Create new DataColumn, set DataType, 
        ' ColumnName and add to DataTable.    
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ID"
        column.[ReadOnly] = True
        ' Add the Column to the DataColumnCollection.
        table.Columns.Add(column)

        ' Create second column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ParentID"
        column.AutoIncrement = False
        column.Caption = "ParentID"
        column.[ReadOnly] = False
        column.Unique = False
        column.AllowDBNull = True

        ' Add the column to the table. 
        table.Columns.Add(column)

        ' Create third column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Name"
        column.AutoIncrement = False
        column.Caption = "Name"
        column.[ReadOnly] = False
        column.Unique = False
        ' Add the column to the table.
        table.Columns.Add(column)


        ' Make the ID column the primary key column.
        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = table.Columns("ID")
        table.PrimaryKey = PrimaryKeyColumns

        row = table.NewRow()
        row("ID") = 1
        row("ParentID") = 1
        row("Name") = "Ratt"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 2
        row("ParentID") = 1
        row("Name") = "Whitesnake"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 3
        row("ParentID") = 2
        row("Name") = "Van Halen"
        table.Rows.Add(row)

        Return table

    End Function

    Private Function GetTableSongs() As DataTable
        ' Create a new DataTable.
        Dim table As System.Data.DataTable = New DataTable("Songs")
        ' Declare variables for DataColumn and DataRow objects.
        Dim column As DataColumn
        Dim row As DataRow

        ' Create new DataColumn, set DataType, 
        ' ColumnName and add to DataTable.    
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ID"
        column.[ReadOnly] = True
        ' Add the Column to the DataColumnCollection.
        table.Columns.Add(column)

        ' Create second column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "ParentID"
        column.AutoIncrement = False
        column.Caption = "ParentID"
        column.[ReadOnly] = False
        column.Unique = False
        column.AllowDBNull = True

        ' Add the column to the table. 
        table.Columns.Add(column)

        ' Create third column.
        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Name"
        column.AutoIncrement = False
        column.Caption = "Name"
        column.[ReadOnly] = False
        column.Unique = False
        ' Add the column to the table.
        table.Columns.Add(column)


        ' Make the ID column the primary key column.
        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = table.Columns("ID")
        table.PrimaryKey = PrimaryKeyColumns

        row = table.NewRow()
        row("ID") = 1
        row("ParentID") = 1
        row("Name") = "Out of the Cellar"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 2
        row("ParentID") = 1
        row("Name") = "Invasion of your Privacy"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 3
        row("ParentID") = 2
        row("Name") = "Slide it in"
        table.Rows.Add(row)

        row = table.NewRow()
        row("ID") = 4
        row("ParentID") = 3
        row("Name") = "Fair Warning"
        table.Rows.Add(row)

        Return table

    End Function

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim dataset As DataSet
        'Create DataSet
        dataset = New DataSet()
        'Add two tables
        dataset.Tables.Add(GetTableGenres())
        dataset.Tables.Add(GetTableBands())
        dataset.Tables.Add(GetTableSongs())


        'Create relations
        Dim parentColumn As DataColumn = dataset.Tables(0).Columns("ID")
        Dim childColumn As DataColumn = dataset.Tables(1).Columns("ParentID")
        Dim genreBandsRelation As New DataRelation("RelationName", parentColumn, childColumn)

        Dim parentColumn1 As DataColumn = dataset.Tables(1).Columns("ID")
        Dim childColumn1 As DataColumn = dataset.Tables(2).Columns("ParentID")
        Dim bandsSongsRelation As New DataRelation("RelationName1", parentColumn1, childColumn1)

        dataset.Relations.Add(genreBandsRelation)
        dataset.Relations.Add(bandsSongsRelation)

        WebHierarchicalDataGrid1.DataSource = dataset

    End Sub
End Class
